using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.Entity;
using System.Data.Entity.Core;
using System.Data.Entity.Core.EntityClient;
using System.Data.Entity.Core.Metadata.Edm;
using System.Data.Entity.Core.Objects;
using System.Data.Entity.Core.Objects.DataClasses;
using System.Diagnostics;
using System.Linq;
using System.Reflection;
using System.Runtime.Serialization;
using System.Xml.Serialization;
using InsERT.Mox.DataAccess;
using InsERT.Mox.DataAccess.EntityFramework;
using InsERT.Mox.DataBinding;
using InsERT.Mox.DataBinding.EntityFramework;
using InsERT.Mox.Validation;
using InsERT.Mox.Work;

#region assembly-level metadata

[assembly: EdmSchema]
[assembly: System.Runtime.InteropServices.ComVisible(false)]
[assembly: CLSCompliant(true)]

[assembly: AssemblyVersion("1.0.0.0")]
[assembly: EdmRelationship(
	"MoxDataModel",
	"FK_Order_Details_Orders",
	"Orders",
	RelationshipMultiplicity.One,
	typeof(MoxDataModel.Orders),
	"Order_Details",
	RelationshipMultiplicity.Many,
	typeof(MoxDataModel.Order_Details))]

#endregion

namespace MoxDataModel
{
	#region entity types
/// <summary></summary>
/// <remarks></remarks>
	[EdmEntityType(NamespaceName = "MoxDataModel", Name = "Order_Details")]
    [Serializable]
    [DataContract(IsReference = true)]
	[System.CodeDom.Compiler.GeneratedCodeAttribute("InsERT.Mox.DataModeling.DataModelCSharpCodeGenerator", "1.0.0.0")]	
		public 	
	class Order_Details
		: EntityDataObjectBase
	{
		#region type intitialization & runtime type information
		
		private static readonly System.Collections.Generic.Dictionary<string, RelationshipTraversalInfo> relationshipTraversalInfo = new RelationshipTraversalInfo[] 
		{
			FK_Order_Details_OrdersTraversalInfoStore.Order_Details,
		}.ToDictionary(rti => rti.NavigationPropertyName);
		
/// <summary>
/// Ta własność jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
/// </summary>
        protected override IDictionary<string, RelationshipTraversalInfo> RelationshipTraversalInfo
        {
            get
            {
                return relationshipTraversalInfo;
            }
        }

/// <summary>
/// Ta własność jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
/// </summary>
		protected override bool TryGetInfoForRelatedEndCore(IRelatedEnd relatedEnd, out RelationshipTraversalInfo info)
        {
			var relationshipManager = ((IEntityWithRelationships)this).RelationshipManager;
			if (false)
			{
			}
			else if (relatedEnd == relationshipManager.GetRelatedEnd("FK_Order_Details_Orders", "Orders"))
			{
				info = FK_Order_Details_OrdersTraversalInfoStore.Order_Details;
				return true;
			}
			else
			{            
            	info = null;
				return false;
			}
        }
		
		#endregion
	
		#region instance initialization

/// <summary>
/// Domyślny konstruktor <see cref="T:MoxDataModel.Order_Details" />.
/// </summary>
		public Order_Details()
		{
			ValidateOrderID(_OrderID);
			ValidateProductID(_ProductID);
			ValidateUnitPrice(_UnitPrice);
			ValidateQuantity(_Quantity);
			ValidateDiscount(_Discount);
		}
		
/// <summary>
/// Ta metoda jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
/// </summary>
		protected override bool SubscribeToAssociationChangedEventsCore(string navigationProperty)
		{
			if (base.SubscribeToAssociationChangedEventsCore(navigationProperty))
			{
				if (navigationProperty == "Orders")
				{
					var relatedEnd = OrdersRelatedEnd;
					ValidateOrdersRelatedEnd(relatedEnd);
					relatedEnd.AssociationChanged += HandleOrdersRelatedEndAssociationChanged;
					return false;
				}
				return true;
			}
			else
			{
				return false;
			}
		}
		#endregion

		#region relationship validation & change notification
		
		private void ValidateOrdersRelatedEnd(EntityReference<Orders> relatedEnd)
		{			
			ValidateRequiredEntityReference(relatedEnd, "Orders");
		}
		
		private void HandleOrdersRelatedEndAssociationChanged(object sender, CollectionChangeEventArgs e)
		{
			DataErrorInfo.RemoveAllErrors("Orders");
			var entityReference = (EntityReference<Orders>)sender;
			ValidateOrdersRelatedEnd(entityReference);
			HandleImplicitAssociationChange(entityReference, e, "Orders");
		}
		
		#endregion
	
		#region scalar property validation
		
		private void ValidateOrderID(System.Int32 value)
		{
		}
		
		private void ValidateProductID(System.Int32 value)
		{
		}
		
		private void ValidateUnitPrice(System.Decimal value)
		{
		}
		
		private void ValidateQuantity(System.Int16 value)
		{
		}
		
		private void ValidateDiscount(System.Single value)
		{
		}
		
		#endregion
	
	
		#region scalar properties
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.Int32 _OrderID = default(System.Int32);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = true, IsNullable = false)]
		[DataMember]
		public System.Int32 OrderID
		{
			get
			{
				return _OrderID;
			}

			internal
			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				DataErrorInfo.RemoveAllErrors("OrderID");
				ValidateOrderID(value);
				ReportPropertyChanging("OrderID");
				_OrderID = value;
				ReportPropertyChanged("OrderID");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.Int32 _ProductID = default(System.Int32);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = true, IsNullable = false)]
		[DataMember]
		public System.Int32 ProductID
		{
			get
			{
				return _ProductID;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "ProductID");
				DataErrorInfo.RemoveAllErrors("ProductID");
				ReportScalarPropertyChanging(sink, "ProductID", ref value);
				ValidateProductID(value);
				ReportPropertyChanging("ProductID");
				_ProductID = value;
				ReportPropertyChanged("ProductID");
				ReportScalarPropertyChanged(sink, "ProductID");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.Decimal _UnitPrice = default(System.Decimal);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.Decimal UnitPrice
		{
			get
			{
				return _UnitPrice;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "UnitPrice");
				DataErrorInfo.RemoveAllErrors("UnitPrice");
				ReportScalarPropertyChanging(sink, "UnitPrice", ref value);
				ValidateUnitPrice(value);
				ReportPropertyChanging("UnitPrice");
				_UnitPrice = value;
				ReportPropertyChanged("UnitPrice");
				ReportScalarPropertyChanged(sink, "UnitPrice");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.Int16 _Quantity = default(System.Int16);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.Int16 Quantity
		{
			get
			{
				return _Quantity;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "Quantity");
				DataErrorInfo.RemoveAllErrors("Quantity");
				ReportScalarPropertyChanging(sink, "Quantity", ref value);
				ValidateQuantity(value);
				ReportPropertyChanging("Quantity");
				_Quantity = value;
				ReportPropertyChanged("Quantity");
				ReportScalarPropertyChanged(sink, "Quantity");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.Single _Discount = default(System.Single);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.Single Discount
		{
			get
			{
				return _Discount;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "Discount");
				DataErrorInfo.RemoveAllErrors("Discount");
				ReportScalarPropertyChanging(sink, "Discount", ref value);
				ValidateDiscount(value);
				ReportPropertyChanging("Discount");
				_Discount = value;
				ReportPropertyChanged("Discount");
				ReportScalarPropertyChanged(sink, "Discount");
			}
		}
		
		#endregion
		
		#region complex properties
		
		
		#endregion
		
		#region navigation properties
/// <summary>
/// Ta własność jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
/// </summary>
		[DataMember]
		protected internal EntityReference<Orders> OrdersRelatedEnd
		{
			get
			{
				IEntityWithRelationships ewr = this;
				return ewr.RelationshipManager.GetRelatedReference<Orders>("FK_Order_Details_Orders", "Orders");
			}
			set
			{
				if (value != null)
				{
					IEntityWithRelationships ewr = this;
					ewr.RelationshipManager.InitializeRelatedReference<Orders>("FK_Order_Details_Orders", "Orders", value);
				}
			}
		}
		
		internal object OrdersNoLazyLoading
		{
			get			
			{
				var context = ObjectContext;
				if (context == null || !context.ContextOption_LazyLoadingEnabled)
				{
					return Orders;
				}
				else
				{
					try
					{
						context.ContextOption_LazyLoadingEnabled = false;
						return Orders;
					}
					finally
					{
						context.ContextOption_LazyLoadingEnabled = true;
					}
				}
			}
		}
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmRelationshipNavigationProperty("MoxDataModel", "FK_Order_Details_Orders", "Orders")]
		[XmlIgnore]
		[SoapIgnore]
		[DataMember]
		public Orders Orders
		{
			get
			{
				return LoadEntityReference(OrdersRelatedEnd);
			}
			
			set
			{
				HandleExplicitAssociationChange(OrdersRelatedEnd, value, "Orders");
			}
		}
		
		#endregion
	}
/// <summary></summary>
/// <remarks></remarks>
	[EdmEntityType(NamespaceName = "MoxDataModel", Name = "Orders")]
    [Serializable]
    [DataContract(IsReference = true)]
	[System.CodeDom.Compiler.GeneratedCodeAttribute("InsERT.Mox.DataModeling.DataModelCSharpCodeGenerator", "1.0.0.0")]	
		public 	
	class Orders
		: EntityDataObjectBase
		, IIdentifiable<System.Int32>
	{
		#region type intitialization & runtime type information
		
		private static readonly System.Collections.Generic.Dictionary<string, RelationshipTraversalInfo> relationshipTraversalInfo = new RelationshipTraversalInfo[] 
		{
			FK_Order_Details_OrdersTraversalInfoStore.Orders,
		}.ToDictionary(rti => rti.NavigationPropertyName);
		
/// <summary>
/// Ta własność jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
/// </summary>
        protected override IDictionary<string, RelationshipTraversalInfo> RelationshipTraversalInfo
        {
            get
            {
                return relationshipTraversalInfo;
            }
        }

/// <summary>
/// Ta własność jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
/// </summary>
		protected override bool TryGetInfoForRelatedEndCore(IRelatedEnd relatedEnd, out RelationshipTraversalInfo info)
        {
			var relationshipManager = ((IEntityWithRelationships)this).RelationshipManager;
			if (false)
			{
			}
			else if (relatedEnd == relationshipManager.GetRelatedEnd("FK_Order_Details_Orders", "Order_Details"))
			{
				info = FK_Order_Details_OrdersTraversalInfoStore.Orders;
				return true;
			}
			else
			{            
            	info = null;
				return false;
			}
        }
		
		#endregion
	
		#region instance initialization

/// <summary>
/// Domyślny konstruktor <see cref="T:MoxDataModel.Orders" />.
/// </summary>
		public Orders()
		{
			ValidateOrderID(_OrderID);
			ValidateCustomerID(_CustomerID);
			ValidateEmployeeID(_EmployeeID);
			ValidateOrderDate(_OrderDate);
			ValidateRequiredDate(_RequiredDate);
			ValidateShippedDate(_ShippedDate);
			ValidateShipVia(_ShipVia);
			ValidateFreight(_Freight);
			ValidateShipName(_ShipName);
			ValidateShipAddress(_ShipAddress);
			ValidateShipCity(_ShipCity);
			ValidateShipRegion(_ShipRegion);
			ValidateShipPostalCode(_ShipPostalCode);
			ValidateShipCountry(_ShipCountry);
		}
		
/// <summary>
/// Ta metoda jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
/// </summary>
		protected override bool SubscribeToAssociationChangedEventsCore(string navigationProperty)
		{
			if (base.SubscribeToAssociationChangedEventsCore(navigationProperty))
			{
				if (navigationProperty == "Order_Details")
				{
					var relatedEnd = Order_DetailsRelatedEnd;
					ValidateOrder_DetailsRelatedEnd(relatedEnd);
					relatedEnd.AssociationChanged += HandleOrder_DetailsRelatedEndAssociationChanged;
					return false;
				}
				return true;
			}
			else
			{
				return false;
			}
		}
		#endregion

		#region relationship validation & change notification
		
		private void ValidateOrder_DetailsRelatedEnd(EntityCollection<Order_Details> relatedEnd)
		{
		}
		
		private void HandleOrder_DetailsRelatedEndAssociationChanged(object sender, CollectionChangeEventArgs e)
		{
			DataErrorInfo.RemoveAllErrors("Order_Details");
			var entityCollection = (EntityCollection<Order_Details>)sender;
			ValidateOrder_DetailsRelatedEnd(entityCollection);
			HandleImplicitAssociationChange(entityCollection, e, "Order_Details");			
		}
		
		#endregion
	
		#region scalar property validation
		
		private void ValidateOrderID(System.Int32 value)
		{
		}
		
		private void ValidateCustomerID(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "CustomerID");
			}
			if (value != null && value.Length != 5)
			{
				DataErrorInfo.AddError(new StringLengthError(5, 5), "CustomerID");
			}
		}
		
		private void ValidateEmployeeID(System.Int32 value)
		{
		}
		
		private void ValidateOrderDate(System.DateTime value)
		{
		}
		
		private void ValidateRequiredDate(System.DateTime value)
		{
		}
		
		private void ValidateShippedDate(System.DateTime value)
		{
		}
		
		private void ValidateShipVia(System.Int32 value)
		{
		}
		
		private void ValidateFreight(System.Decimal value)
		{
		}
		
		private void ValidateShipName(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "ShipName");
			}
			if (value != null && value.Length > 40)
			{
				DataErrorInfo.AddError(new StringLengthError(40, false), "ShipName");
			}
		}
		
		private void ValidateShipAddress(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "ShipAddress");
			}
			if (value != null && value.Length > 60)
			{
				DataErrorInfo.AddError(new StringLengthError(60, false), "ShipAddress");
			}
		}
		
		private void ValidateShipCity(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "ShipCity");
			}
			if (value != null && value.Length > 15)
			{
				DataErrorInfo.AddError(new StringLengthError(15, false), "ShipCity");
			}
		}
		
		private void ValidateShipRegion(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "ShipRegion");
			}
			if (value != null && value.Length > 15)
			{
				DataErrorInfo.AddError(new StringLengthError(15, false), "ShipRegion");
			}
		}
		
		private void ValidateShipPostalCode(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "ShipPostalCode");
			}
			if (value != null && value.Length > 10)
			{
				DataErrorInfo.AddError(new StringLengthError(10, false), "ShipPostalCode");
			}
		}
		
		private void ValidateShipCountry(System.String value)
		{
			if (value == null)
			{
				DataErrorInfo.AddError(new MemberIsNullError(), "ShipCountry");
			}
			if (value != null && value.Length > 15)
			{
				DataErrorInfo.AddError(new StringLengthError(15, false), "ShipCountry");
			}
		}
		
		#endregion
	
		#region explicit identifier accessor
		
		System.Int32 IIdentifiable<System.Int32>.Id
		{
			get
			{
				return OrderID;
			}			
		}
		
		object IIdentifiable.Id
		{
			get
			{
				return OrderID;
			}
		}
		
		Type IIdentifiable.IdType
		{
			get
			{
				return typeof(System.Int32);
			}
		}
		
		#endregion
	
		#region scalar properties
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.Int32 _OrderID = default(System.Int32);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = true, IsNullable = false)]
		[DataMember]
		public System.Int32 OrderID
		{
			get
			{
				return _OrderID;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				DataErrorInfo.RemoveAllErrors("OrderID");
				ReportScalarPropertyChanging(sink, "OrderID", ref value);
				ValidateOrderID(value);
				ReportPropertyChanging("OrderID");
				_OrderID = value;
				ReportPropertyChanged("OrderID");
				ReportScalarPropertyChanged(sink, "OrderID");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _CustomerID = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String CustomerID
		{
			get
			{
				return _CustomerID;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "CustomerID");
				DataErrorInfo.RemoveAllErrors("CustomerID");
				ReportScalarPropertyChanging(sink, "CustomerID", ref value);
				ValidateCustomerID(value);
				ReportPropertyChanging("CustomerID");
				_CustomerID = value;
				ReportPropertyChanged("CustomerID");
				ReportScalarPropertyChanged(sink, "CustomerID");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.Int32 _EmployeeID = default(System.Int32);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.Int32 EmployeeID
		{
			get
			{
				return _EmployeeID;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "EmployeeID");
				DataErrorInfo.RemoveAllErrors("EmployeeID");
				ReportScalarPropertyChanging(sink, "EmployeeID", ref value);
				ValidateEmployeeID(value);
				ReportPropertyChanging("EmployeeID");
				_EmployeeID = value;
				ReportPropertyChanged("EmployeeID");
				ReportScalarPropertyChanged(sink, "EmployeeID");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.DateTime _OrderDate = default(System.DateTime);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.DateTime OrderDate
		{
			get
			{
				return _OrderDate;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "OrderDate");
				DataErrorInfo.RemoveAllErrors("OrderDate");
				ReportScalarPropertyChanging(sink, "OrderDate", ref value);
				ValidateOrderDate(value);
				ReportPropertyChanging("OrderDate");
				_OrderDate = value;
				ReportPropertyChanged("OrderDate");
				ReportScalarPropertyChanged(sink, "OrderDate");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.DateTime _RequiredDate = default(System.DateTime);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.DateTime RequiredDate
		{
			get
			{
				return _RequiredDate;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "RequiredDate");
				DataErrorInfo.RemoveAllErrors("RequiredDate");
				ReportScalarPropertyChanging(sink, "RequiredDate", ref value);
				ValidateRequiredDate(value);
				ReportPropertyChanging("RequiredDate");
				_RequiredDate = value;
				ReportPropertyChanged("RequiredDate");
				ReportScalarPropertyChanged(sink, "RequiredDate");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.DateTime _ShippedDate = default(System.DateTime);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.DateTime ShippedDate
		{
			get
			{
				return _ShippedDate;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "ShippedDate");
				DataErrorInfo.RemoveAllErrors("ShippedDate");
				ReportScalarPropertyChanging(sink, "ShippedDate", ref value);
				ValidateShippedDate(value);
				ReportPropertyChanging("ShippedDate");
				_ShippedDate = value;
				ReportPropertyChanged("ShippedDate");
				ReportScalarPropertyChanged(sink, "ShippedDate");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.Int32 _ShipVia = default(System.Int32);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.Int32 ShipVia
		{
			get
			{
				return _ShipVia;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "ShipVia");
				DataErrorInfo.RemoveAllErrors("ShipVia");
				ReportScalarPropertyChanging(sink, "ShipVia", ref value);
				ValidateShipVia(value);
				ReportPropertyChanging("ShipVia");
				_ShipVia = value;
				ReportPropertyChanged("ShipVia");
				ReportScalarPropertyChanged(sink, "ShipVia");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.Decimal _Freight = default(System.Decimal);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.Decimal Freight
		{
			get
			{
				return _Freight;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "Freight");
				DataErrorInfo.RemoveAllErrors("Freight");
				ReportScalarPropertyChanging(sink, "Freight", ref value);
				ValidateFreight(value);
				ReportPropertyChanging("Freight");
				_Freight = value;
				ReportPropertyChanged("Freight");
				ReportScalarPropertyChanged(sink, "Freight");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _ShipName = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String ShipName
		{
			get
			{
				return _ShipName;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "ShipName");
				DataErrorInfo.RemoveAllErrors("ShipName");
				ReportScalarPropertyChanging(sink, "ShipName", ref value);
				ValidateShipName(value);
				ReportPropertyChanging("ShipName");
				_ShipName = value;
				ReportPropertyChanged("ShipName");
				ReportScalarPropertyChanged(sink, "ShipName");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _ShipAddress = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String ShipAddress
		{
			get
			{
				return _ShipAddress;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "ShipAddress");
				DataErrorInfo.RemoveAllErrors("ShipAddress");
				ReportScalarPropertyChanging(sink, "ShipAddress", ref value);
				ValidateShipAddress(value);
				ReportPropertyChanging("ShipAddress");
				_ShipAddress = value;
				ReportPropertyChanged("ShipAddress");
				ReportScalarPropertyChanged(sink, "ShipAddress");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _ShipCity = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String ShipCity
		{
			get
			{
				return _ShipCity;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "ShipCity");
				DataErrorInfo.RemoveAllErrors("ShipCity");
				ReportScalarPropertyChanging(sink, "ShipCity", ref value);
				ValidateShipCity(value);
				ReportPropertyChanging("ShipCity");
				_ShipCity = value;
				ReportPropertyChanged("ShipCity");
				ReportScalarPropertyChanged(sink, "ShipCity");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _ShipRegion = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String ShipRegion
		{
			get
			{
				return _ShipRegion;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "ShipRegion");
				DataErrorInfo.RemoveAllErrors("ShipRegion");
				ReportScalarPropertyChanging(sink, "ShipRegion", ref value);
				ValidateShipRegion(value);
				ReportPropertyChanging("ShipRegion");
				_ShipRegion = value;
				ReportPropertyChanged("ShipRegion");
				ReportScalarPropertyChanged(sink, "ShipRegion");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _ShipPostalCode = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String ShipPostalCode
		{
			get
			{
				return _ShipPostalCode;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "ShipPostalCode");
				DataErrorInfo.RemoveAllErrors("ShipPostalCode");
				ReportScalarPropertyChanging(sink, "ShipPostalCode", ref value);
				ValidateShipPostalCode(value);
				ReportPropertyChanging("ShipPostalCode");
				_ShipPostalCode = value;
				ReportPropertyChanged("ShipPostalCode");
				ReportScalarPropertyChanged(sink, "ShipPostalCode");
			}
		}
		
		[DebuggerBrowsable(DebuggerBrowsableState.Never)]
		private System.String _ShipCountry = default(System.String);
		
/// <summary></summary>
/// <remarks></remarks>
		[EdmScalarProperty(EntityKeyProperty = false, IsNullable = false)]
		[DataMember]
		public System.String ShipCountry
		{
			get
			{
				return _ShipCountry;
			}

			set
			{
				object sponsor = sponsorRef == null ? null : sponsorRef.Target;
				IDataEventsSink sink = sponsor as IDataEventsSink;
				CheckPropertyChange(sponsor, "ShipCountry");
				DataErrorInfo.RemoveAllErrors("ShipCountry");
				ReportScalarPropertyChanging(sink, "ShipCountry", ref value);
				ValidateShipCountry(value);
				ReportPropertyChanging("ShipCountry");
				_ShipCountry = value;
				ReportPropertyChanged("ShipCountry");
				ReportScalarPropertyChanged(sink, "ShipCountry");
			}
		}
		
		#endregion
		
		#region complex properties
		
		
		#endregion
		
		#region navigation properties
/// <summary>
/// Ta własność jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
/// </summary>
		[DataMember]
		protected internal
		EntityCollection<Order_Details> Order_DetailsRelatedEnd
		{
			get
			{
				IEntityWithRelationships ewr = this;
				return ewr.RelationshipManager.GetRelatedCollection<Order_Details>("FK_Order_Details_Orders", "Order_Details");
			}
			set
			{
				if (value != null)
				{
					IEntityWithRelationships ewr = this;
					ewr.RelationshipManager.InitializeRelatedCollection<Order_Details>("FK_Order_Details_Orders", "Order_Details", value);
				}				
			}
		}
		
		internal object Order_DetailsNoLazyLoading
		{
			get			
			{
				var context = ObjectContext;
				if (context == null || !context.ContextOption_LazyLoadingEnabled)
				{
					return Order_Details;
				}
				else
				{
					try
					{
						context.ContextOption_LazyLoadingEnabled = false;
						return Order_Details.ToArray();
					}
					finally
					{
						context.ContextOption_LazyLoadingEnabled = true;
					}
				}
			}
		}
		
		private WrappedEntityCollection<Order_Details> _wrappedOrder_Details;

		private WrappedEntityCollection<Order_Details> WrappedOrder_Details
		{
			get
			{
				if (_wrappedOrder_Details == null)
				{
					_wrappedOrder_Details = new WrappedEntityCollection<Order_Details>(this, "Order_Details", "Orders");
				}
				_wrappedOrder_Details.UnderlyingEntityCollection = Order_DetailsRelatedEnd;
				return _wrappedOrder_Details;
			}
		}
		

/// <summary></summary>
/// <remarks></remarks>
		[EdmRelationshipNavigationProperty("MoxDataModel", "FK_Order_Details_Orders", "Order_Details")]
		[XmlIgnore]
		[SoapIgnore]
		public
		ICollection<Order_Details> Order_Details
		{
			get
			{
				return WrappedOrder_Details;
			}
		}						
		#endregion
	}
	#endregion
	
	#region complex types

	#endregion
	
	#region runtime type information store
	
	[System.CodeDom.Compiler.GeneratedCodeAttribute("InsERT.Mox.DataModeling.DataModelCSharpCodeGenerator", "1.0.0.0")]
	internal static class FK_Order_Details_OrdersTraversalInfoStore
	{
		static FK_Order_Details_OrdersTraversalInfoStore()
		{
			RelationshipTraversalInfo.CreatePair
			(
				typeof(Orders),
				"Order_Details",
				true,
				o =>
				{
					var e = (Orders)o;
					return e.Order_DetailsNoLazyLoading;
				},
				
				typeof(Order_Details),
				"Orders",
				false,
				o =>
				{
					var e = (Order_Details)o;					
					return e.OrdersNoLazyLoading;
				},

				out Orders,
				out Order_Details
			);
		}
		
		internal static readonly RelationshipTraversalInfo Orders;
		internal static readonly RelationshipTraversalInfo Order_Details;
	}
	
	#endregion

	#region repository & eager relationship loading interfaces & implementation
	
/// <summary>
/// Ładuje encje bezpośrednio powiązane z encjami typu <see cref="T:MoxDataModel.Order_Details" />
/// </summary>
	[System.CodeDom.Compiler.GeneratedCodeAttribute("InsERT.Mox.DataModeling.DataModelCSharpCodeGenerator", "1.0.0.0")]
	
	public interface IOrder_DetailsRelationshipLoader
	{
/// <summary>
/// Sprawdza, czy dla danej encji typu <see cref="T:MoxDataModel.Order_Details" /> jest załadowana powiązana encja osiągalna przez własność <see cref="P:MoxDataModel.Order_Details.Orders" />.
/// </summary>
		bool IsOrdersLoaded(Order_Details order_details);		
/// <summary>
/// Ładuje powiązaną encję osiągalną przez własność <see cref="P:MoxDataModel.Order_Details.Orders" /> w podanej encji typu <see cref="T:MoxDataModel.Order_Details" />.
/// </summary>
		void LoadOrders(Order_Details order_details);
	}
	
/// <summary>
/// Repozytorium encji typu <see cref="T:MoxDataModel.Order_Details" />
/// </summary>
	[System.CodeDom.Compiler.GeneratedCodeAttribute("InsERT.Mox.DataModeling.DataModelCSharpCodeGenerator", "1.0.0.0")]
	public interface IOrder_DetailsRepository
		: IRepository<Order_Details>
		, IOrder_DetailsRelationshipLoader
	{
	}
	
/// <summary>
/// Repozytorium encji typu <see cref="MoxDataModel.Order_Details" /> ze zbioru Order_Details.
/// </summary>
	public class EFOrder_DetailsFromOrder_DetailsRepository
		: EFRepositoryBase<Order_Details, Order_Details, dbo>
		, IOrder_DetailsRepository
		, InsERT.Mox.ObiektyBiznesowe.IDane<Order_Details>
	{
/// <summary>
/// Tworzy repozytorium pobierające encje w podanym kontekście ADO.NET EF.
/// </summary>
		public EFOrder_DetailsFromOrder_DetailsRepository(dbo objectContext)
			: base(objectContext)
		{
		}
		
/// <summary>
/// Zbiór encji, z którego korzysta repozytorium.
/// </summary>
		protected override ObjectSet<Order_Details> ObjectSet
		{
			get
			{
				return ObjectContext.Order_Details;
			}
		}
		
/// <summary>
/// Sprawdza, czy dla danej encji typu <see cref="T:MoxDataModel.Order_Details" /> jest załadowana powiązana encja osiągalna przez własność <see cref="P:MoxDataModel.Order_Details.Orders" />.
/// </summary>
		public bool IsOrdersLoaded(Order_Details order_details)
		{
			return order_details.OrdersRelatedEnd.IsLoaded;
		}
		
/// <summary>
/// Ładuje powiązaną encję osiągalną przez własność <see cref="P:MoxDataModel.Order_Details.Orders" /> w podanej encji typu <see cref="T:MoxDataModel.Order_Details" />.
/// </summary>
		public void LoadOrders(Order_Details order_details)
		{
			if (order_details.EntityState == EntityState.Unchanged ||
				order_details.EntityState == EntityState.Modified)
			{
				order_details.OrdersRelatedEnd.Load();
			}
		}
				
	}

	
/// <summary>
/// Ładuje encje bezpośrednio powiązane z encjami typu <see cref="T:MoxDataModel.Orders" />
/// </summary>
	[System.CodeDom.Compiler.GeneratedCodeAttribute("InsERT.Mox.DataModeling.DataModelCSharpCodeGenerator", "1.0.0.0")]
	
	public interface IOrdersRelationshipLoader
	{
/// <summary>
/// Sprawdza, czy dla danej encji typu <see cref="T:MoxDataModel.Orders" /> są załadowane powiązane encje osiągalne przez własność <see cref="P:MoxDataModel.Orders.Order_Details" />.
/// </summary>
		bool AreOrder_DetailsLoaded(Orders orders);
/// <summary>
/// Ładuje powiązane encje osiągalne przez własność <see cref="P:MoxDataModel.Orders.Order_Details" /> w podanej encji typu <see cref="T:MoxDataModel.Orders" />.
/// </summary>
		void LoadOrder_Details(Orders orders);
	}
	
/// <summary>
/// Repozytorium encji typu <see cref="T:MoxDataModel.Orders" />
/// </summary>
	[System.CodeDom.Compiler.GeneratedCodeAttribute("InsERT.Mox.DataModeling.DataModelCSharpCodeGenerator", "1.0.0.0")]
	public interface IOrdersRepository
		: IRepository<Orders, System.Int32>
		, IOrdersRelationshipLoader
	{
	}
	
/// <summary>
/// Repozytorium encji typu <see cref="MoxDataModel.Orders" /> ze zbioru Orders.
/// </summary>
	[System.CodeDom.Compiler.GeneratedCodeAttribute("InsERT.Mox.DataModeling.DataModelCSharpCodeGenerator", "1.0.0.0")]
	public class EFOrdersFromOrdersRepository
		: EFRepositoryBase<Orders, Orders, System.Int32, dbo>
		, IOrdersRepository
		, InsERT.Mox.ObiektyBiznesowe.IDane<Orders>
	{
/// <summary>
/// Tworzy repozytorium pobierające encje w podanym kontekście ADO.NET EF.
/// </summary>
		public EFOrdersFromOrdersRepository(dbo objectContext)
			: base(objectContext)
		{
		}
		
/// <summary>
/// Zbiór encji, z którego korzysta repozytorium.
/// </summary>
		protected override ObjectSet<Orders> ObjectSet
		{
			get
			{
				return ObjectContext.Orders;
			}
		}
		
/// <summary>
/// Sprawdza, czy dla danej encji typu <see cref="T:MoxDataModel.Orders" /> są załadowane powiązane encje osiągalne przez własność <see cref="P:MoxDataModel.Orders.Order_Details" />.
/// </summary>
		public bool AreOrder_DetailsLoaded(Orders orders)
		{
			return orders.Order_DetailsRelatedEnd.IsLoaded;
		}
		
/// <summary>
/// Ładuje powiązane encje osiągalne przez własność <see cref="P:MoxDataModel.Orders.Order_Details" /> w podanej encji typu <see cref="T:MoxDataModel.Orders" />.
/// </summary>
		public void LoadOrder_Details(Orders orders)
		{
			if (orders.EntityState == EntityState.Unchanged ||
				orders.EntityState == EntityState.Modified)
			{
				orders.Order_DetailsRelatedEnd.Load();
			}
		}
				
	}

	
	
	#endregion

	#region entity containers
	
/// <summary>
/// Kontekst obiektowy ADO.NET EF.
/// </summary>
	[System.CodeDom.Compiler.GeneratedCodeAttribute("InsERT.Mox.DataModeling.DataModelCSharpCodeGenerator", "1.0.0.0")]
	public class dbo :  UnitOfWorkAwareObjectContext  
	{

/// <summary>
/// Tworzy kontekst, connection string pobierając z app.config.
/// </summary>
		public dbo()
			: base("name=dbo", "dbo")
		{
			MetadataWorkspace.LoadFromAssembly(Assembly.GetExecutingAssembly());
		}

/// <summary>
/// Tworzy kontekst używający podanego connection stringa.
/// </summary>
		public dbo(string connectionString)
			: base(connectionString, "dbo")
		{
			MetadataWorkspace.LoadFromAssembly(Assembly.GetExecutingAssembly());
		}
		
/// <summary>
/// Tworzy kontekst używający podanego połączenia.
/// </summary>
		public dbo(EntityConnection connection)
			: base(connection, "dbo")
		{
			MetadataWorkspace.LoadFromAssembly(Assembly.GetExecutingAssembly());
		}
		
		private ObjectSet<Order_Details> _Order_Details;

/// <summary>
/// Encje ze zbioru Order_Details.
/// </summary>
	public ObjectSet<Order_Details> Order_Details
		{
			get
			{
				if (_Order_Details == null)
				{
					_Order_Details = CreateObjectSet<Order_Details>("Order_Details");
				}
				return _Order_Details;
			}
		}
		
		private ObjectSet<Orders> _Orders;

/// <summary>
/// Encje ze zbioru Orders.
/// </summary>
	public ObjectSet<Orders> Orders
		{
			get
			{
				if (_Orders == null)
				{
					_Orders = CreateObjectSet<Orders>("Orders");
				}
				return _Orders;
			}
		}
		
	}	

	#endregion

	#region model-defined constraint validation helpers
	

	
	#endregion

	#region module manifest
	
	/// <summary>
	/// Ta klasa jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
	/// </summary>
	[System.CodeDom.Compiler.GeneratedCodeAttribute("InsERT.Mox.DataModeling.DataModelCSharpCodeGenerator", "1.0.0.0")]
	public sealed class ModuleManifest : InsERT.Mox.Runtime.EntityFramework.IEdmModuleManifest
	{
		/// <summary>
		/// Ta własność jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
		/// </summary>
		public IEnumerable<Type> ObjectContextTypes 
		{ 
			get
			{
				return new[]
				{
					typeof(dbo),
				};
			}
		}
		
		/// <summary>
		/// Ta własność jest wykorzystywana przez wewnętrzne mechanizmy platformy Morii i nie powinna być bezpośrednio używana w kodzie zewnętrznym.
		/// </summary>
		public IEnumerable<InsERT.Mox.Runtime.EntityFramework.RepositoryRegistration> RepositoryRegistrations
		{
			get
			{
				return new[]
				{
				new InsERT.Mox.Runtime.EntityFramework.RepositoryRegistration
				(
					typeof(IOrder_DetailsRepository),
					new Type[] { typeof(InsERT.Mox.ObiektyBiznesowe.IDane<Order_Details>), typeof(IRepository<Order_Details>) },
					new Tuple<Type, string, Type>[]
					{ 
						Tuple.Create(typeof(dbo), "Order_Details", typeof(EFOrder_DetailsFromOrder_DetailsRepository)),
					},
					"Order_Details" 
				),
				new InsERT.Mox.Runtime.EntityFramework.RepositoryRegistration
				(
					typeof(IOrdersRepository),
					new Type[] { typeof(InsERT.Mox.ObiektyBiznesowe.IDane<Orders>), typeof(IRepository<Orders>), typeof(IRepository<Orders, System.Int32>) },
					new Tuple<Type, string, Type>[]
					{ 
						Tuple.Create(typeof(dbo), "Orders", typeof(EFOrdersFromOrdersRepository)),
					},
					"Orders" 
				),
				};
			}
		}
	}
	
	#endregion

}
